commit 978bacb758ddbbdee71772a5acafa1db4683950a
Author: Alexandre Oliva <oliva@adacore.com>
Date:   Tue Jul 7 09:02:01 2020 +0200

    accept <case> and [cond] in ChangeLog
    
    Only '(' and ':' currently terminate file lists in ChangeLog entries
    in the ChangeLog parser.  This rules out such legitimate entries as:
    
    * filename <CASE>:
    * filename [COND]:
    
    This patch extends the ChangeLog parser to recognize these forms.
    
    for  contrib/ChangeLog
    
            * gcc-changelog/git_commit.py: Support CASE and COND.
            * gcc-changelog/test_patches.txt: Add test.
            * gcc-changelog/test_email.py: Add test.
    
    Co-Authored-By: Martin Liska <mliska@suse.cz>
    (cherry picked from commit a759bfc7cf238b9fc5bf97884297fc69d8cdf2b5)

diff --git a/contrib/gcc-changelog/git_commit.py b/contrib/gcc-changelog/git_commit.py
index 4d003ccf496..827976c2f84 100755
--- a/contrib/gcc-changelog/git_commit.py
+++ b/contrib/gcc-changelog/git_commit.py
@@ -154,6 +154,7 @@ changelog_regex = re.compile(r'^(?:[fF]or +)?([a-z0-9+-/]*)ChangeLog:?')
 pr_regex = re.compile(r'\tPR (?P<component>[a-z+-]+\/)?([0-9]+)$')
 dr_regex = re.compile(r'\tDR ([0-9]+)$')
 star_prefix_regex = re.compile(r'\t\*(?P<spaces>\ *)(?P<content>.*)')
+end_of_location_regex = re.compile(r'[\[<(:]')
 
 LINE_LIMIT = 100
 TAB_WIDTH = 8
@@ -204,14 +205,13 @@ class ChangeLogEntry:
                 line = m.group('content')
 
             if in_location:
-                # Strip everything that is not a filename in "line": entities
-                # "(NAME)", entry text (the colon, if present, and anything
-                # that follows it).
-                if '(' in line:
-                    line = line[:line.index('(')]
-                    in_location = False
-                if ':' in line:
-                    line = line[:line.index(':')]
+                # Strip everything that is not a filename in "line":
+                # entities "(NAME)", cases "<PATTERN>", conditions
+                # "[COND]", entry text (the colon, if present, and
+                # anything that follows it).
+                m = end_of_location_regex.search(line)
+                if m:
+                    line = line[:m.start()]
                     in_location = False
 
                 # At this point, all that's left is a list of filenames
diff --git a/contrib/gcc-changelog/test_email.py b/contrib/gcc-changelog/test_email.py
index 1c9f8847fe7..b6fbe6a5303 100755
--- a/contrib/gcc-changelog/test_email.py
+++ b/contrib/gcc-changelog/test_email.py
@@ -361,3 +361,7 @@ class TestGccChangelog(unittest.TestCase):
         assert '\tBackported from master:' in entry
         assert '\t2020-06-11  Martin Liska  <mliska@suse.cz>' in entry
         assert '\t\t    Jakub Jelinek  <jakub@redhat.com>' in entry
+
+    def test_square_and_lt_gt(self):
+        email = self.from_patch_glob('0001-Check-for-more-missing')
+        assert not email.errors
